/*********************************************************
Program Name: 	DColor
Coder:         Jeremy C. Witt
Email:			wittj@onramp.net
Web:				http://www.cryptnet1.net
Date:				March 1999
Module Name:	dc.h
Desc:				Prototype and Structure Definitions...
**********************************************************/

/*Various Includes*/
/******************/
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <dir.h>

/*Defines*/
/*********/
#define HelpText "DColor /h for Help"


/*Abrash's Zen Timer for Optimization tests*/
/*To use Uncomment, and include pcltnear.obj*/
/*as a build node, and call with ZTIMERON(); <Stuff>;*/
/*ZTIMEROFF(); ZTIMERREPORT(); NOTE: You must run in DOS Mode*/
/*******************************************/
/*extern void ZTIMERON();
extern void ZTIMEROFF();
extern void ZTIMERREPORT();
*/




/*Function PROTOTYPES*/
/*********************/
void placeHeader();
void placeFooter();
void initStuff();

/*type = the type of file it is Hence the color*/
int placeText(int type);

/*ret value is type(color) and file[x] is formatted for output*/
int parseFileName(int iterator);
void finishLine(int numleft);
int chooseColor(char*extension);
void printSize();
void ShowHelp();
void QuickSort(int,int);
int Partition(int,int);

/*Structure Definitions*/
/***********************/

/*DCData is a static linked list of file info
 Terminator is a filepart with empty string
 Implemented is a Doubly Linked List for fast
 Sorting using the Insertion Sort.*/
typedef struct DCData
{
	char file[13]; 	/*FileName*/
   long size;        /*Size of File*/
   int  directory;   /*IsDirectory?*/
} dcdata;

/*This Structure Holds the Various Command Line Options*/
typedef struct PData
{
	char qualif[48];		/*This is the Search Mask that is on the Command Line*/
   int  BreakonPages;   /*To Stop or Not to Stop on Page List*/
   int  LinestoDisplay; /*# of Lines Per PageBreak (only if BreakonPages=1*/
   int  SortType;			/*0=Unsorted,1=File,2=Ext,3=Size,(4)=date*/
   int  UpDown;			/*UpDown Display = 1; Left Right = 0 (Def)*/
} pdata;

/*Global Data Parts*/
/*******************/

/*This Holds the Horizontal Rule String
  it is Dynamically changed for bottom
  or top rule usage*/
char hrule[82];

/*These Hold the Segment Breaks and Line
  breaks which are called when needed*/
char widget0[2];
long totalsize; 		/*Total Size of the Files in the Directory*/
int  totalfiles;		/*Total Number of Files*/
int  iterator;   		/*Current File of 1000 to iterate*/
int FilesMo;	  		/*More Data To Output/Process?*/
dcdata JData[1000];	/*This is the Main File Data Stuct*/
dcdata SortHolder;
pdata	 ParamData;    /*This holds Current Param Data*/

